<?php

include('submenu.php');
include('esgfw_functions.php');

$all_hosts=get_objects("$SERVER_ID","host");
$all_networks=get_objects("$SERVER_ID","network");
$all_services=get_objects("$SERVER_ID","service");
$fw_interfaces=get_fwinterfaces("$SERVER_ID");


//install && Save
if ($_GET['action'] == 'install'){
	$retval=installpolicy();
	if ($retval == "OK"){
		$topmsg_success="Done";
		}else{
		$topmsg_error="Failed: $retval";
	};
};	
if ($_GET['action'] == 'save'){
	$retval=savepolicy();
	if ($retval == "OK"){
		$topmsg_success="Done";
		}else{
		$topmsg_error="Failed: $retval";
	};
};	

//Move Up/Down
if ($_GET['action'] == 'up'){
	$rid=$_GET['id'];
	if (is_numeric($rid)){
		//find the type & number of rule
		$query="select rulenum from esgfw_nat where id='$rid' and server_id='$SERVER_ID'";
		$result=mysql_query($query) or die ("ERROR".mysql_error());
		$row=mysql_fetch_row($result);
		$rulenum=$row[0];
		$nattype=$row[1];
		$newrule=move_rule_up("$SERVER_ID","$rulenum","$nattype");
		if (is_numeric($newrule)){
			$query="update esgfw_nat set rulenum='$newrule' where id='$rid'";
			mysql_query($query) or die ("ERROR".mysql_error());
			$topmsg_success="Rule moved";
			}else{
			$topmsg_error="Error";
		};
	};
};

if ($_GET['action'] == 'down'){
        $rid=$_GET['id'];
        if (is_numeric($rid)){
                //find the type & number of rule
                $query="select rulenum,nattype from esgfw_nat where id='$rid' and server_id='$SERVER_ID'";
                $result=mysql_query($query) or die ("ERROR".mysql_error());
                $row=mysql_fetch_row($result);
                $rulenum=$row[0];
                $nattype=$row[1];
                $newrule=move_rule_down("$SERVER_ID","$rulenum","$nattype");
                if (is_numeric($newrule)){
                        $query="update esgfw_nat set rulenum='$newrule' where id='$rid'";
                        mysql_query($query) or die ("ERROR".mysql_error());
                        $topmsg_success="Rule moved";
                        }else{
                        $topmsg_error="Error";
                };
        };
};


// Save 
if (isset($_POST['save'])){
	$enable=$_POST['enable'];
	$rulenum=$_POST['rulenum'];
	$description=$_POST['description'];
	$description=addslashes($description);

	$update=$_GET['update'];
	$update=addslashes($update);

	$source=$_POST['source'];
	$destination=$_POST['destination'];
	$negate=$_POST['negate'];
	$service=$_POST['service'];
	$interface=$_POST['interface'];
	$direction=$_POST['direction'];
	$action=$_POST['action'];
	$log=$_POST['log'];

	$error=0;
	//Validation
	//---------------
	// 1. Rule Number
	if (!is_numeric($update)){
		//New Rule - not allow the same num
		$query="select rulenum from esgfw_rules where rulenum='$rulenum' and server_id='$SERVER_ID'";
		$result=mysql_query($query) or die ("ERROR".mysql_error());
		$NUM=mysql_num_rows($result);
		if ($NUM > 0){
			$error='1';
			$error_msg='Duplicate RuleNum';
		};


		}else{  //update rule
		$query="select rulenum from esgfw_rules where rulenum='$rulenum' and server_id='$SERVER_ID' and id!='$update'";
		$result=mysql_query($query) or die ("ERROR".mysql_error());
		$NUM=mysql_num_rows($result);
		if ($NUM > 0){
			$error='1';
			$error_msg='Duplicate RuleNum';
		};

	};
		
	// 2. Destination FW - NO negate
	if (!is_numeric($destination)){  //'any' of 'fw' interface
		if ($negate == 'yes'){
			$error=1;
			$error_msg="Can not use negate";
		};
	};

	// 3. Check Interface
	if (!is_numeric($destination) && $destination != "any"){ //fw ethernet
		if ($interface != 'any'){
			$error=1;
			$error_msg="Interface should be any";
		};
	};
	if (!is_numeric($source) && $source != "any"){ //fw ethernet
		if ($interface != 'any'){
			$error=1;
			$error_msg="Interface should be any";
		};
	};
	
	// 3. FW to FW
	if ($source == 'fw' && $destination == 'fw'){
		$error=1;
		$error_msg="FW to FW NOT allowed";
	};

	// 4. Direction
	if ($interface != 'any' && $direction == 'both'){
		$error=1;
		$error_msg="Interface requires direction";
	};

	//If ok - Validation pass
	//--------------------------
	if ($error == 0){
		if (!is_numeric($update)){
			//New Rule
			$query="insert into esgfw_rules(id,server_id,rulenum,source,destination,negate,service,interface,direction,action,log,enable,comments) values('','$SERVER_ID','$rulenum','$source','$destination','$negate','$service','$interface','$direction','$action','$log','$enable','$description')";
			}else{
			//Update Rule
			$query="update esgfw_rules set rulenum='$rulenum',source='$source',destination='$destination',negate='$negate',service='$service',interface='$interface',direction='$direction',action='$action',enable='$enable',log='$log',comments='$description' where id='$update' and server_id='$SERVER_ID'";
		};
		mysql_query($query) or die ("ERROR".mysql_error());
		$topmsg_success="Rule saved";
		}else{
		$topmsg_error="An error occured [$error_msg]";
	};
};


//Delete
if (isset($_GET['action']) && $_GET['action'] == 'delete'){
	$dbid=$_GET['id'];
	if (is_numeric($dbid)){
		$query="delete from esgfw_rules where id='$dbid' and server_id='$SERVER_ID'";
		mysql_query($query) or die ("ERROR".mysql_error());
		$topmsg_success="Rule Removed";
		}else{
		$topmsg_error="invalid id";
	};
};

/* Edit Rule */
if (isset($_GET['action']) && $_GET['action'] == "edit_rule"){
        $dbid=$_GET['id'];
        $dbid=addslashes($dbid);
        $editid=$dbid;
        if (is_numeric($dbid)){
                $editform_rule="$(\"#addform\").slideDown(300);";
                $query="select id,rulenum,source,destination,negate,service,interface,direction,action,log,enable,comments from esgfw_rules where id='$dbid' and server_id='$SERVER_ID'";
                $result=mysql_query($query) or die ("ERROR".mysql_error());
                $row=mysql_fetch_row($result);
                $editid=$row[0];
                $edit_rulenum=$row[1];
                $edit_source=$row[2];
		if (is_numeric($edit_source)){
	                $source_name=get_object_name("$SERVER_ID","$edit_source");
        	        $edit_source="<option value=\"$edit_source\">$source_name</option>";
			}else{
        	        $edit_source="<option value=\"$edit_source\">$edit_source</option>";
		};
                $edit_destination=$row[3];
		if (is_numeric($edit_destination)){
	                $destination_name=get_object_name("$SERVER_ID","$edit_destination");
        	        $edit_destination="<option value=\"$edit_destination\">$destination_name</option>";
			}else{
        	        $edit_destination="<option value=\"$edit_destination\">$edit_destination</option>";
		};

                $edit_negate=$row[4];
		if ($edit_negate == 'yes'){
			$edit_negate='checked';
		};

		$edit_service=$row[5];
		if (is_numeric($edit_service)){
			$service_name=get_object_name("$SERVER_ID","$edit_service");
			$edit_service="<option value=\"$edit_service\">$service_name</option>";
		};



		$edit_interface=$row[6];
		$edit_interface="<option>$edit_interface</option>";
		$edit_direction=$row[7];
		$edit_direction="<option>$edit_direction</option>";
		$edit_action=$row[8];
		$edit_action="<option>$edit_action</option>";
		
		$edit_log=$row[9];
		if ($edit_log == "yes"){
			$edit_log='checked';
		};
		$edit_enable=$row[10];
		if ($edit_enable == "yes"){
			$edit_enable="checked";
		};
		$edit_description=$row[11];

        };

};


$myrules='';
$query="select id,rulenum,source,destination,negate,service,interface,direction,action,log,enable,comments from esgfw_rules where server_id='$SERVER_ID' order by rulenum";
$result=mysql_query($query) or die ("ERROR".mysql_error());
while(list($id,$rulenum,$source,$destination,$negate,$service,$interface,$direction,$action,$log,$enable,$comments)=mysql_fetch_array($result)){
        if ($enable == 'yes'){
                $status='<i class="fa fa-check-circle" aria-hidden="true" style="color:#008000"></i>';
                }else{
                $status='<i class="fa fa-exclamation-circle" aria-hidden="true" style="color:#dd3333;"></i>';
        };
        if (is_numeric($source)){
                $source=get_object_name("$SERVER_ID","$source");
		}else{
		if ($source != 'any' && $source !='fw'){ //netcard
			$source="<img src=\"pics/network_card.png\" style=\"height:22px;\">&nbsp;<span style=\"size:80%;color:#666;\">FW-$source</span>";
		};
		if ($source == 'fw'){ //fireall
			$source="<img src=\"pics/firewall1.jpg\" style=\"height:22px;\">&nbsp;<span style=\"size:80%;color:#666;\">Firewall</span>";
		};
        };
	if (is_numeric($destination)){
		$destination=get_object_name("$SERVER_ID","$destination");
		}else{
		if ($destination != 'any' && $destination != 'fw'){ //netcard
			$destination="<img src=\"pics/network_card.png\" style=\"height:22px;\">&nbsp;<span style=\"size:80%;color:#666;\">FW-$destination</span>";
		};
		if ($destination == 'fw'){ //fireall
			$destination="<img src=\"pics/firewall1.jpg\" style=\"height:22px;\">&nbsp;<span style=\"size:80%;color:#666;\">Firewall</span>";
		};
	};
	if (is_numeric($service)){
		$service=get_object_name("$SERVER_ID","$service");
	};
	if ($negate == 'yes'){
		$negate="<i class=\"fa fa-minus-circle\" aria-hidden=\"true\" style=\"color:#dd3333;\">&nbsp;</i>";
		}else{
		$negate='';
	};

	if ($interface != 'any'){
		$interface="<img src=\"pics/network_card.png\" style=\"height:22px;\">&nbsp;<span style=\"size:80%;color:#666;\">FW-$interface</span>";
	};

	$action_style="";
	if ($action == "ACCEPT"){
		$action_style="background-color:#008000;color:#fff;font-size:80%;border-radius:3px;padding:4px 5px;";
	};
	if ($action == "REJECT"){
		$action_style="background-color:#dd3333;color:#fff;font-size:80%;border-radius:3px;padding:4px 5px;";
	};
	if ($action == "DROP"){
		$action_style="background-color:#fff;color:#dd3333;font-size:80%;border:1px solid #dd3333;border-radius:3px;padding:3px 12px;";
	};
	if ($direction == "in"){
		$direction="<i class=\"fa fa-long-arrow-down\" aria-hidden=\"true\">&nbsp;</i>Inbound";
	};
	if ($direction == "out"){
		$direction="<i class=\"fa fa-long-arrow-up\" aria-hidden=\"true\">&nbsp;</i>Outbound";
	};
	if ($direction == "both"){
		$direction="<i class=\"fa fa-long-arrow-up\" aria-hidden=\"true\">&nbsp;</i><i class=\"fa fa-long-arrow-down\" aria-hidden=\"true\">&nbsp;</i>Both";
	};
        if ($log == 'yes'){
                $log='<i class="fa fa-file-text" aria-hidden="true" style="color:#A52A2A"></i>';
                }else{
		$log='-';
        };
	
        $myrules.=<<<EOF
        <tr>
                <td>$rulenum</td>
                <td>$source</td>
		<td>$negate$destination</td>
                <td>$service</td>
                <td>$interface</td>
                <td>$direction</td>
                <td><span style="$action_style">$action</span></td>
                <td style="text-align:center;">$log</td>
                <td style="width:80px;">
                        $status&nbsp;&nbsp;
                        <a href="index.php?module=esgfw&cmd=policy&action=edit_rule&id=$id"><i class="fa fa-edit" aria-hidden="true" style="color:#333;"></i></a>&nbsp;&nbsp;
                <!--    <a href="index.php?module=esgfw&cmd=policy&action=up&id=$id"><i class="fa fa-long-arrow-up" aria-hidden="true" style="color:#333;"></i></a>&nbsp;&nbsp;
                        <a href="index.php?module=esgfw&cmd=policy&action=down&id=$id"><i class="fa fa-long-arrow-down" aria-hidden="true" style="color:#333;"></i></a>&nbsp;&nbsp; -->
                        <a href="index.php?module=esgfw&cmd=policy&action=delete&id=$id"><i class="fa fa-trash" aria-hidden="true" style="color:#dd3333;"></i></a>
                </td>
        </tr>
EOF;
};


$module_page=<<<EOF
<script>
$(document).ready(function(){
        $("#push_policy").click(function(){
            $("#pushpolicy").slideDown(300);
        });
        $("#add_rule").click(function(){
            $("#addform").slideDown(300);
        });
	$editform_rule
});
</script>

<!-- FORM FOR INSTALL POLICY -->
<div class="drop_form" style="display:none;padding:20px;" id="pushpolicy">
<form method="POST" action="?module=esgfw&cmd=policy">
        <table class="page_table" style="width:100%;" border="0">
                <tr>
                        <th class="drop_form_header" colspan="3" style="background-color:#dd3333;">Push Policy</th>
                </tr>
		<tr>
			<td colspan="3" style="text-align:center;">What do you want to do?</td>
		</tr>
		<tr>
			<td style="width:40%;text-align:right;">
				<a href="?module=esgfw&cmd=policy&action=save" style="text-decoration:none;color:#fff;padding:10px 5px;border:1px solid #333;background-color:#009090">Save to Device</a>
			</td>
			<td>&nbsp;</td>
			<td style="width:40%;">
				<a href="?module=esgfw&cmd=policy&action=install" style="text-decoration:none;color:#fff;padding:10px 5px;border:1px solid #333;background-color:#008000">Install to Device</a>
			</td>
		</tr>
		<tr>
			<td colspan="3" style="border-bottom:1px solid #666;">&nbsp;</td>
		<tr>
			<td colspan="3">
			<div><span style="color:#009090;font-weight:bold;">&rarr; Save to Device</span> : Save policy to device but DO NOT install</div><br>
			<div><span style="color:#008000;font-weight:bold;">&rarr; Install to Device</span> : Install LAST SAVED policy to device</div><br>
			</td>
		</tr>
		
	</table>
</form>
</div>


<!-- FORM FOR ADD RULE -->
<div class="drop_form" style="display:none;padding:20px;" id="addform">
<form method="POST" action="?module=esgfw&cmd=policy&update=$editid">
        <table class="page_table" style="width:100%;">
                <tr>
                        <th class="drop_form_header" colspan="2">Add/Edit rule</th>
                </tr>
                <tr>
                        <td>Enable</td>
                        <td><input type="checkbox" name="enable" value="yes" $edit_enable></td>
                </tr>
                <tr>
                        <td>Rule Num</td>
                        <td><input type="number" style="width:300px;" name="rulenum" min="100" max="999" required value="$edit_rulenum"></td>
                </tr>
                <tr>
                        <td>Description</td>
                        <td>
				<input type="text" style="width:300px;" name="description" required value="$edit_description">
			</td>
                </tr>
                <tr>
                        <td>Source</td>
                        <td>
                                <select style="width:310px;" name="source" required>
                                $edit_source
				<option>any</option>
                                <option disabled style="background-color:#fff;font-weight:bold;color:#00b2ee;">Hosts</option>
                                $all_hosts
                                <option disabled style="background-color:#fff;font-weight:bold;color:#00b2ee;">Networks</option>
                                $all_networks
			        <option disabled style="background-color:#fff;font-weight:bold;color:#00b2ee;">Firewall</option>
				<option value="fw">FW_ANY (any)</option>
				$fw_interfaces
                                </select>
                        </td>
                </tr>

                <tr>
                        <td style="vertical-align:top;">Destination</td>
                        <td>
                                <select style="width:310px;" name="destination" required>
                                $edit_destination
                                <option>any</option>
			        <option disabled style="background-color:#fff;font-weight:bold;color:#00b2ee;">Hosts</option>
                                $all_hosts
                                <option disabled style="background-color:#fff;font-weight:bold;color:#00b2ee;">Networks</option>
                                $all_networks
			        <option disabled style="background-color:#fff;font-weight:bold;color:#00b2ee;">Firewall</option>
				<option value="fw">FW_ANY (any)</option>
				$fw_interfaces
                                </select><br>
				<input type="checkbox" name="negate" value="yes" $edit_negate> Negate
                        </td>
                </tr>

                <tr>
                        <td>Service</td>
                        <td>
                                <select style="width:310px;" name="service" required>
                                $edit_service
                                <option>any</option>
                                <option disabled style="background-color:#fff;font-weight:bold;color:#00b2ee;">Services</option>
                                $all_services
                                </select>
                        </td>
                </tr>

                <tr>
                        <td>Interface</td>
                        <td>
                                <select style="width:310px;" name="interface" required>
                                $edit_interface
                                <option value="any">any Interface</option>
				$fw_interfaces
                                </select>
                        </td>
                </tr>

                <tr>
                        <td>Direction</td>
                        <td>
                                <select style="width:310px;" name="direction" required>
                                $edit_direction
                                <option value="both">Bidirectional (both)</option>
                                <option value="in">Inbound (In)</option>
                                <option value="out">Outbound (Out)</option>
                                </select>
                        </td>
                </tr>
                <tr>
                        <td>Action</td>
                        <td>
                                <select style="width:310px;" name="action" required>
                                $edit_action
                                <option>DROP</option>
                                <option>REJECT</option>
                                <option>ACCEPT</option>
                                </select>
                        </td>
                </tr>
                <tr>
                        <td>Log</td>
                        <td><input type="checkbox" name="log" value="yes" $edit_log></td>
                </tr>


                <tr>
                        <td></td>
                        <td><button class="button_blue" type="submit" name="save">Save</button> or <a href="?module=esgfw&cmd=policy">Cancel</a></td>
                </tr>
        </table>
</form>
</div>


<table class="page_table">
	<tr>
		<th class="page_table_header" colspan="9">FW Policy
			$submenu
		</th>
	</tr>
	<tr>
		<td style="border-bottom:1px solid #333;font-weight:bold;color:#555;" colspan="9">
			<span style="margin-left:-10px;background-color:#fafafa;padding:4px;border-radius:3px;border:1px solid #f1f1f1;">
				Rules
			</span>
			<span style="float:right;background-color:#dd3333;padding:0.1em;color:#fff;">
				<i class="fa fa-plus" aria-hidden="true" style="cursor:pointer;" id="add_rule"></i>
			</span>
		</td>
	<tr>
	<tr>
                <td class="list_header">Num</td>
                <td class="list_header">Source</td>
                <td class="list_header">Destination</td>
                <td class="list_header">Service</td>
                <td class="list_header">Interface</td>
                <td class="list_header">Direction</td>
                <td class="list_header">Action</td>
                <td class="list_header" style="width:30px;">Log</td>
                <td class="list_header"></td>
        </tr>

	$myrules


</table>

EOF;

?>
