<?php
/**
 * Redirects to specified page
 *
 * @param string $page Page to redirect user to
 * @return void
 */
function redirect($page) {
        header('Location: ' . $page);
        exit();
}

/** Flush buffer to browser */
function hardFlush (){
    echo(str_repeat(' ',256));
    // check that buffer is actually set before flushing
    if (ob_get_length()){
        @ob_flush();
        @flush();
        @ob_end_flush();
    }
    @ob_start();
}

/** E-Mail validator  */
function check_email_address($email_a) {
        if (filter_var($email_a, FILTER_VALIDATE_EMAIL)) {
                return true;
                }else{
                return false;
        };
};

/** Date Validator **/
//function validateDate($date, $format = 'Y-m-d H:i:s'){
function validateDate($date, $format = 'Y-m-d'){
    $d = DateTime::createFromFormat($format, $date);
    return $d && $d->format($format) == $date;
}

//Date converter US --> EU (2012-03-24 --> 24/03/2012)
function date_convert_eu($date){
        $date_array = explode("-",$date);
        $theyear=$date_array[0];
        $themonth=$date_array[1];
        $theday=$date_array[2];
        $eu_date="$theday/$themonth/$theyear";
        return $eu_date;
};


//Get Objects (object = service,host,network
function get_objects ($SERVER_ID,$object){
	$myobjects='';
	$query="select id,name from secfs_objects where object='$object' and server_id='$SERVER_ID'";
	$result=mysql_query($query) or die ("ERROR".mysql_error());
	while(list($oid,$oname)=mysql_fetch_array($result)){
		$myobjects.=<<<EOF
		<option value="$oid">$oname</option>
EOF;
	};

	return "$myobjects";
};

function get_object_name ($SERVER_ID,$oid){
	$query="select name from secfs_objects where id='$oid' and server_id='$SERVER_ID'";
	$result=mysql_query($query) or die ("ERROR".mysql_error());
	$row=mysql_fetch_row($result);
	$name=$row[0];

	return "$name";
};

?>
