<?php

session_start();
error_reporting( error_reporting() & ~E_NOTICE );
date_default_timezone_set('Asia/Nicosia');
ob_start("ob_gzhandler");

/* 
  SECFS 
*/

if (file_exists('dbconnect.php')){
	include('dbconnect.php');
	}else{
	$NOT_INSTALLED=<<<EOF
<html>
<head></head>
<body>
<p style="font-size:120%;font-weight:bold;text-decoration:underline;">Secure File Server</p>
<p style="">Unfinished installation. Please run as 'root' #<B>secfs_admin -i</b>
</body>
</html>
EOF;
	echo $NOT_INSTALLED;
	exit;
};

include('functions.php');
include('version.php');

mysql_connect("localhost","$dbuser","$dbpass");
@mysql_select_db($dbname) or die ("FATAL-ERROR".mysql_error());


$thisyear=date('Y');

//Logout
if ($_GET['cmd'] == 'logout'){
	$_SESSION = array();
	session_destroy();
};
if ($_SESSION['secfs_login'] != true) {
        redirect('login.php');
        exit();
};

/* Browser Info */
$userip=$_SERVER['REMOTE_ADDR'];

//Session Parameters
$myname=$_SESSION['secfs_name'];
$secfs_userid=$_SESSION['secfs_userid'];

include('header.php');

// The main body
// Will chnage if cmd ...
$module_page=<<<EOF
<table style="width:100%;border-collapse:collapse;">
<tr>
        <th colspan="10">&nbsp;</th>
</tr>
<tr>
<td>
<div style="margin:0 auto;text-align:center;padding-top:50px;font-weight:bold;font-size:300%;">
Secure FileServer
</div>
<div style="margin:0 auto;text-align:center;padding-top:10px;font-weight:bold;font-size:150%;color:#666;">
Enterprise Secure Fileserver for businesses
</div>
<div style="margin:0 auto;text-align:center;padding-top:10px;font-weight:bold;font-size:100%;color:#666;">
Ver: $ver-$release
</div>
</td>
</tr>
</table>
EOF;
if (isset($_GET['module']) && $_GET['module'] != '' ){
	$module=$_GET['module'];
	$module=addslashes($module);
	if (isset($_GET['cmd']) && $_GET['cmd'] != '' ){
		$cmd=$_GET['cmd'];
		$cmd=addslashes($cmd);
		if (file_exists("modules/$module/$cmd.php")){
			include("modules/$module/$cmd.php");
		};
	};
};
		


$html=<<<EOF
<!doctype html>
<html>
<head>
<title>Secure FileServer</title>
<link rel="stylesheet" href="css/myclass.css" TYPE="text/css">

<link rel="stylesheet" type="text/css" href="css/ddlevelsfiles/ddlevelsmenu-base.css" /> 
<link rel="stylesheet" type="text/css" href="css/ddlevelsfiles/ddlevelsmenu-topbar.css" /> 
<link rel="stylesheet" type="text/css" href="css/ddlevelsfiles/ddlevelsmenu-sidebar.css" /> 
<link rel="stylesheet" href="css/font-awesome-4.7.0/css/font-awesome.min.css">

<script type="text/javascript" src="css/ddlevelsfiles/ddlevelsmenu.js">

        /***********************************************
        * All Levels Navigational Menu- (c) Dynamic Drive DHTML code library (http://www.dynamicdrive.com)
        * This notice MUST stay intact for legal use
        * Visit Dynamic Drive at http://www.dynamicdrive.com/ for full source code
        ***********************************************/

</script>


<!-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script> -->
<script src="jquery/jquery-1.10.2.min.js"></script>

<!-- Dropdown Menu - icons,links ... everything -->
<link type="text/css" rel="stylesheet" href="jquery/jquery-dropdown-master/jquery.dropdown.css" />
<script type="text/javascript" src="jquery/jquery-dropdown-master/jquery.dropdown.js"></script>

<script>
$(document).ready(function(){
        $("#jtopmsg").delay(1000).slideDown(300);
        $("#jtopmsg").delay(3000).slideUp(300);
});
</script>



</head>

<body>
<table class="container" align="center">
	<tr>
		<td class="header">$header</td>
	</tr>
	<tr>
		<td class="mainbody">$module_page</td>
	</tr>
</table>

</body>
EOF;

//Show top messages
//--------------------
if ("$topmsg_success" != ""){
        $html.=<<<EOF
<!-- DIV TO SHOW TOP MESSAGES -->
  <div class="topmsg_success" id="jtopmsg" style="display:none;">
         $topmsg_success
  </div>
<!-- END OF DIV -->
EOF;
};

if ("$topmsg_info" != ""){
        $html.=<<<EOF
<!-- DIV TO SHOW TOP MESSAGES -->
  <div class="topmsg_info" id="jtopmsg" style="display:none;">
         $topmsg_info
  </div>
<!-- END OF DIV -->
EOF;
};

if ("$topmsg_error" != ""){
        $html.=<<<EOF
<!-- DIV TO SHOW TOP MESSAGES -->
  <div class="topmsg_error" id="jtopmsg" style="display:none;">
         $topmsg_error
  </div>
<!-- END OF DIV -->
EOF;
};

if ("$topmsg_warning" != ""){
        $html.=<<<EOF
<!-- DIV TO SHOW TOP MESSAGES -->
  <div class="topmsg_warning" id="jtopmsg" style="display:none;">
         $topmsg_warning
  </div>
<!-- END OF DIV -->
EOF;
};


$html.=<<<EOF
</html>
EOF;
echo $html;


?>
